<template>
  <div class="station-chart-panel query-panel d-flex flex-grow-1 flex-row">
    <div class="plot-settings-area d-flex flex-grow-0 flex-column bg-light px-4 py-3" style="overflow-y: scroll; min-width: 20rem">
      <div>
        <h4 class="pb-2">Estações</h4>
        <div v-for="option in options" :key="option.id" class="plot-option-status-control custom-control custom-switch pb-1">
          <input type="checkbox" class="custom-control-input" :id="option.id" :value="option.status" v-model="option.status">
          <label class="custom-control-label plot-option-control-label" :for="option.id">{{ option.title }}</label>
        </div>
      </div>
    </div>

    <div class="plot-chart-area d-flex flex-grow-1 flex-column">
      <template v-if="loading">
        <div class="d-flex flex-grow-1">
          <div class="mx-auto my-4">
            <h2 class="text-center mt-4">A carregar...</h2>
            <span class="align-middle">
              <clip-loader :loading="loading" color="#007bff" size="50px" radius="100%"/>
            </span>
          </div>
        </div>
      </template>
      <template v-else>
        <div class="chart-container">
          <base-chart ref="chart" :styles="chartStyle()" :options="chartOptions" :chart-data="chartData"/>
        </div>
      </template>
    </div>
  </div>
</template>

<script>
import uuid from 'uuid'
import axios from 'axios'
import ClipLoader from 'vue-spinner/src/ClipLoader'
import BaseChart from '@/core/charts/mixins/BaseChart'
import { DEFAULT_CHART_OPTIONS } from '@/plots/chart'
import axisList from '@/plots/settings/axis'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'

export default {
  name: 'StationChartPanel',

  mixins: [
    WorkspaceGetter
  ],

  components: {
    ClipLoader,
    BaseChart
  },

  data () {
    return {
      options: [{
        id: uuid(),
        status: false,
        name: 'pressure',
        title: 'Pressão',
        axis: 'pressure-axis',
        settings: {
          order: 2,
          type: 'line',
          fill: 'start',
          label: 'Pressão ao N.M.M.',
          backgroundColor: 'rgba(30, 90, 130, 0.45)',
          borderColor: 'rgba(30, 90, 130, 0.45)',
          pointRadius: 0,
          yAxisID: 'pressure-axis'
        }
      }, {
        id: uuid(),
        status: false,
        name: 'temperature-maximum',
        title: 'Temperatura máxima',
        axis: 'temperature-axis',
        settings: {
          order: 2,
          type: 'line',
          label: 'Temperatura máxima',
          backgroundColor: 'rgba(0, 0, 0, 0)',
          borderColor: '#fa0000',
          yAxisID: 'temperature-axis'
        }
      }, {
        id: uuid(),
        status: false,
        name: 'temperature-minimum',
        axis: 'temperature-axis',
        title: 'Temperatura mínima',
        settings: {
          order: 2,
          type: 'line',
          label: 'Temperatura mínima',
          backgroundColor: 'rgba(0, 0, 0, 0)',
          borderColor: '#fa0000',
          yAxisID: 'temperature-axis'
        }
      }, {
        id: uuid(),
        status: true,
        name: 'temperature-mean',
        axis: 'temperature-axis',
        title: 'Temperatura média',
        settings: {
          order: 2,
          type: 'line',
          label: 'Temperatura média',
          backgroundColor: 'rgba(0, 0, 0, 0)',
          borderColor: '#fa0000',
          yAxisID: 'temperature-axis'
        }
      }, {
        id: uuid(),
        status: false,
        name: 'relative-humidity-minimum',
        axis: 'humidity-axis',
        title: 'Humidade relativa mínima',
        settings: {
          order: 2,
          type: 'line',
          label: 'Humidade relativa mínima',
          backgroundColor: 'rgba(0, 0, 0, 0)',
          borderColor: '#0000fa',
          yAxisID: 'humidity-axis'
        }
      }, {
        id: uuid(),
        status: false,
        name: 'relative-humidity-maximum',
        axis: 'humidity-axis',
        title: 'Humidade relativa máxima',
        settings: {
          order: 2,
          type: 'line',
          label: 'Humidade relativa máxima',
          backgroundColor: 'rgba(0, 0, 0, 0)',
          borderColor: '#0000fa',
          yAxisID: 'humidity-axis'
        }
      }, {
        id: uuid(),
        status: true,
        name: 'relative-humidity-mean',
        axis: 'humidity-axis',
        title: 'Humidade relativa média',
        settings: {
          order: 2,
          type: 'line',
          label: 'Humidade relativa média',
          backgroundColor: 'rgba(0, 0, 0, 0)',
          borderColor: '#0000fa',
          yAxisID: 'humidity-axis'
        }
      }, {
        id: uuid(),
        status: false,
        name: 'precipitation',
        axis: 'precipitation-axis',
        title: 'Precipitação',
        settings: {
          order: 2,
          type: 'bar',
          label: 'Precipitação',
          backgroundColor: 'rgba(112, 172, 196, 200)',
          borderColor: 'rgba(112, 172, 196, 200)',
          yAxisID: 'precipitation-axis',
        }
      }, {
        id: uuid(),
        status: false,
        name: 'precipitation-maximum',
        axis: 'precipitation-axis',
        title: 'Precipitação máxima',
        settings: {
          order: 2,
          type: 'bar',
          label: 'Precipitação máxima',
          backgroundColor: 'rgba(112, 172, 196, 200)',
          borderColor: 'rgba(112, 172, 196, 200)',
          yAxisID: 'precipitation-axis',
        }
      }],
      data: null,
      loading: true,
      error: null
    }
  },

  props: {
    stationId: {
      type: Number,
      required: true
    }
  },

  computed: {
    chartOptions: {
      get () {
        let options = {
          ...DEFAULT_CHART_OPTIONS,
        }

        options.scales.yAxes = this.plotVariables.map(variable => {
          return variable.axis
        }).filter((axis, index, arr) => {
          return arr.indexOf(axis) === index
        }).map((axis, index) => {
          return {
            ...this.getAxis(axis),
            position: index % 2 === 0 ? 'left' : 'right'
          }
        })

        return options
      }
    },

    chartData: {
      get () {
        const datasets = []

        this.plotVariables.forEach(variable => {
          datasets.push({
            ...variable.settings,
            data: this.data[variable.name].map(item => {
              return { t: item.time, y: item.value }
            })
          })
        })

        return {
          datasets
        }
      }
    },

    plotVariables: {
      get () {
        return this.options.filter(option => {
          return option.status === true
        })
      }
    }
  },

  methods: {
    async getData () {
      const response = await axios.get(process.env.VUE_APP_BASE_STATION_QUERY_URL + '/' + this.stationId)
      this.data = response.data.properties
      this.loading = false
    },

    chartStyle () {
      return { height: '300px', position: 'relative' }
    },

    getAxis (name) {
      return Object.values(axisList).find(axis => {
        return axis.id === name
      })
    }
  },

  async mounted () {
    await this.getData()
  }
}
</script>
